100 REMark Maze Solver by Dilwyn Jones for Albin Hessler's CueDark
110 REMark this screen saver is best run compiled
120 :
130 IF Q_MYJOB = 0 THEN CMD$ = '' : REMark no CMD$ IN BASIC JOB 0
140 :
150 comm$ = CMD$
160 IF LEN(comm$) >= 10 THEN
170   REMark get detailspassed by CueDark
180   xsize = HEX(comm$(1 TO 4))      : REMark screen width passed
190   ysize = HEX(comm$(5 TO 8))      : REMark screen height passed
200   path$ = comm$(10 TO LEN(comm$)) : REMark path name passed
210 ELSE
220   IF VER$ = 'HBA' AND Q_MYJOB = 0 THEN
230     REMark SBASIC job 0, use SCR_XLIM etc on primary,
240     REMark use SCR_XLIM etc on primary
250     xsize = SCR_XLIM(#0) : ysize = SCR_YLIM(#0)
260   ELSE
270     REMark a safe fallback if all else fails
280     xsize = 512 : ysize = 256
290   END IF
300   path$ = 'Win1_CueDark_' : REMark not essential in this saver
310 END IF
320 :
330 walk_delay% = 75  : REMark delay between each frame in 1/50ths second
340 view_delay% = 250 : REMark plan of maze shown for this time
350 new_delay%  = 250 : REMark pause between generation of new mazes
360 :
370 REMark open a screen channel to cover whole screen
380 OPEN #3,'scr_'&xsize&'x'&ysize&'a0x0'
390 SCALE #3,100,0,0
400 :
410 REPeat program
420   PAPER #3,0 : INK #3,7 : CLS #3
430   :
440   across = RND(2 TO 14) : REMark maze width
450   down   = RND(2 TO 14) : REMark maze height
460   :
470   REMark print an attractive opening logo
480   CSIZE #3,2,1 : INK #3,2 : OVER #3,1
490   PRINT #3,'Designing a ';across;'x';down;' maze...'
500   INK #3,7 : CURSOR #3,2,1
510   PRINT #3,'Designing a ';across;'x';down;' maze...'
520   CSIZE #3,2,0 : OVER #3,0
530   PAUSE 25
540   :
550   REMark plan a maze with only one guaranteed route through
560   MAKE_A_MAZE
570   :
580   REMark start off at the entrance on the east side
590   x = inx : y = iny
600   :
610   REMark briefly view the 2D plan of the maze
620   MAP_MAZE
630   PAUSE view_delay%
640   :
650   directn    = 1           : REMark 0123 = NESW always starts east
660   stp%       = 1           : REMark 1='Heading...'   0='Turned...'
670   tme        = DATE        : REMark time taken to navigate maze
680   :
690   col_scheme = RND(1 TO 10) : REMark maze colour scheme
700   SELect ON col_scheme
710     =1 : REMark generally green
720          sidewall% = 4 : sideopen% = 220 : exitcol% = 2 : wall% = 220
730     =2 : REMark generally red
740          sidewall% = 2 : sideopen% = 226 : exitcol% = 4 : wall% = 226
750     =3 : REMark generally yellow
760          sidewall% = 2 : sideopen% = 242 : exitcol% = 7 : wall% = 242
770     =4 : REMark generally white
780          sidewall% = 255 : sideopen% = 49 : exitcol% = 7 : wall% = 49
790     =5 : REMark solid colours 1
800          sidewall% = 2 : sideopen% = 4 : exitcol% = 7 : wall% = 4
810     =6 : REMark solid colours 2
820          sidewall% = 4 : sideopen% = 4 : exitcol% = 2 : wall% = 4
830     =7 : REMark stripes red
840          sidewall% = 146 : sideopen% = 80 : exitcol% = 7 : wall% = 80
850     =8 : REMark stripes green
860          sidewall% = 164 : sideopen% = 96 : exitcol% = 7 : wall% = 96
870     =9 : REMark light
880          sidewall% = 7 : sideopen% = 30 : exitcol% = 2 : wall% = 30
890     =10: REMark white/pink
900          sidewall% = 7 : sideopen% = 226 : exitcol% = 2 : wall% = 226
910   END SELect
920   :
930   REPeat walk
940     REMark draw current location view
950     CLS #3  : REMark clear previous display frame
960     :
970     SETVARS : REMark prepare to draw this frame
980     SELect ON directn
990       =0 : REMark north
1000            REPeat loop
1010              CELL 8,2
1020              IF (maze(noy,nox)&&1) = 0 OR noy = 1 THEN EXIT loop
1030              noy = noy - 1 : REMark keep drawing in this direction
1040            END REPeat loop
1050            IF (maze(noy,nox)&&1) = 0 THEN WALLEXIT : ELSE OPENEXIT
1060       =1 : REMark east
1070            REPeat loop
1080              CELL 1,4
1090              IF (maze(noy,nox)&&2) = 0 OR nox = across THEN EXIT loop
1100              nox = nox + 1 : REMark keep drawing in this direction
1110            END REPeat loop
1120            IF (maze(noy,nox)&&2) = 0 THEN WALLEXIT : ELSE OPENEXIT
1130       =2 : REMark south
1140            REPeat loop
1150              CELL 2,8
1160              IF (maze(noy,nox)&&4) = 0 OR noy = down THEN EXIT loop
1170              noy = noy + 1 : REMark keep drawing in this direction
1180            END REPeat loop
1190            IF (maze(noy,nox)&&4) = 0 THEN WALLEXIT : ELSE OPENEXIT
1200       =3 : REMark west
1210            REPeat loop
1220              CELL 4,1
1230              IF (maze(noy,nox)&&8) = 0 OR nox = 1 THEN EXIT loop
1240              nox = nox - 1 : REMark keep drawing in this direction
1250            END REPeat loop
1260            IF (maze(noy,nox)&&8) = 0 THEN WALLEXIT : ELSE OPENEXIT
1270     END SELect
1280     :
1290     REMark show position guide as little dot in maz sized box
1300     BLOCK #3,4*across+4,2*down+2,58,0,2       : REMark outline
1310     BLOCK #3,4*across,2*down,60,1,7           : REMark backing
1320     BLOCK #3,4,2,60+(4*(x-1)),(2*(y-1))+1,0   : REMark position
1330     BLOCK #3,2,2,58,(2*(iny-1))+1,7           : REMark entrance
1340     BLOCK #3,2,2,60+4*across,(2*(outy-1))+1,7 : REMark exit
1350     :
1360     REMark indicate action - "turn" or "heading"
1370     REMark variable "stp%" indicates if any movement forward
1380     INK #3,7 : AT #3,0,10
1390     IF stp% = 1 THEN PRINT #3,'Heading '; : ELSE PRINT #3,'Turned ';
1400     SELect ON directn
1410       =0 : PRINT #3,'North'
1420       =1 : PRINT #3,'East'
1430       =2 : PRINT #3,'South'
1440       =3 : PRINT #3,'West'
1450     END SELect
1460     :
1470     PAUSE walk_delay% : REMark pause per frame
1480     :
1490     REMark determine where to go next
1500     :
1510     REMark ACTION 0: obviously, exit if that is immediately ahead
1520     IF y = outy AND x = outx AND directn = 1 THEN EXIT walk
1530     :
1540     REMark ACTION 1: is the ENTRANCE directly ahead???
1550     IF y = iny AND x = inx AND directn = 3 THEN
1560       REMark silly computer, can't get out that way!
1570       CURSOR #3,80,ysize - 10 : INK #3,4
1580       comment = RND(1 TO 3)
1590       SELect ON comment
1600         =1 : PRINT #3,"OH DEAR,ENTRANCE AHEAD!"
1610         =2 : PRINT #3,"CAN'T GET OUT THAT WAY!"
1620         =3 : PRINT #3,"LOOK FOR EXIT,NOT ENTRY"
1630         =4 : PRINT #3,"THE WRONG WAY OUT,MATE!"
1640       END SELect
1650       REMark continue exploring after slight delay to read message
1660       PAUSE walk_delay%
1670     END IF
1680     :
1690     REMark ACTION 2: if heading north or south past exit,turn to exit
1700     IF (directn = 0 OR directn = 2) AND x = outx AND y = outy THEN
1710       directn = 1 : NEXT walk : REMark turn, don't move
1720     END IF
1730     :
1740     REMark ACTION 3: obvious way is to go forward if possible,
1750     REMark but that would be too easy and predictable
1760     REMark so every 1 in 20 moves take a random turning
1770     IF RND(1 TO 20) = 20 THEN
1780       REMark try a random move
1790       directn2 = RND(0 TO 3)
1800       IF MOVE_IS_OK%(directn2) = 1 THEN NEXT walk
1810     END IF
1820     :
1830     REMark ACTION 4: a 10:1 chance of going straight on if possible
1840     IF RND(1 TO 20) < 19 THEN
1850       REMark try straight on
1860       IF MOVE_IS_OK%(directn) = 1 THEN NEXT walk
1870     END IF
1880     :
1890     REMark ACTION5: the dreaded random number generator decrees
1900     REMark we don't necessarily go straight on even if possible
1910     REMark or it simply was not possible to go straight on
1920     SELect ON directn
1930       =0 : REMark was going north
1940            IF MOVE_IS_OK%(1) = 1 THEN NEXT walk : REMark go east
1950            IF MOVE_IS_OK%(3) = 1 THEN NEXT walk : REMark go west
1960            IF MOVE_IS_OK%(2) = 1 THEN NEXT walk : REMark back south
1970       =1 : REMark was going east
1980            IF MOVE_IS_OK%(0) = 1 THEN NEXT walk : REMark go north
1990            IF MOVE_IS_OK%(2) = 1 THEN NEXT walk : REMark go south
2000            IF MOVE_IS_OK%(3) = 1 THEN NEXT walk : REMark back west
2010       =2 : REMark south
2020            IF MOVE_IS_OK%(1) = 1 THEN NEXT walk : REMark go east
2030            IF MOVE_IS_OK%(3) = 1 THEN NEXT walk : REMark go west
2040            IF MOVE_IS_OK%(0) = 1 THEN NEXT walk : REMark back north
2050       =3 : REMark west
2060            IF MOVE_IS_OK%(0) = 1 THEN NEXT walk : REMark go north
2070            IF MOVE_IS_OK%(2) = 1 THEN NEXT walk : REMark go south
2080            IF MOVE_IS_OK%(1) = 1 THEN NEXT walk : REMark back east
2090     END SELect
2100     :
2110     REMark attempts to move failed if got here, but shouldn't happen
2120     REMark if any bugs in my code means it does, further move
2130     REMark attempts should be placed here
2140   END REPeat walk
2150   :
2160   REMark managed to get out!
2170   cy% = (ysize DIV 2)-10 : CURSOR #3,50,cy%
2180   comment = RND(1 TO 4)
2190   SELect ON comment
2200     =1 : PRINT #3,'** ESCAPED **'
2210     =2 : PRINT #3,'OUT OF THE MAZE!'
2220     =3 : PRINT #3,'GOOD, EXIT FOUND!'
2230     =4 : PRINT #3,'AHA, FOUND THE EXIT!'
2240   END SELect
2250   CURSOR #3,50,cy%+20 : PRINT #3,'IN ';DATE-tme;' SECONDS'
2260   PAUSE new_delay%
2270 END REPeat program
2280 :
2290 CLOSE #3
2300 STOP
2310 :
2320 DEFine PROCedure SETVARS
2330   nox = x : noy = y : xxx = 0 : rx = 99 : yyy = 0
2340   yinc = 10 : xinc = 10 : ht = 100 : shrink = 1.25
2350 END DEFine SETVARS
2360 :
2370 DEFine PROCedure CELL (l,r)
2380   REMark determine how to draw this location (walls etc)
2390   yy = yyy + yinc : xx = xxx + xinc
2400   rxx = rx - xinc : hht = ht - yinc - yinc
2410   :
2420   REMark left hand side
2430   IF (maze(noy,nox)&&l) = l THEN LSIDEOPEN : ELSE LSIDEWALL
2440   :
2450   REMark right hand side
2460   IF (maze(noy,nox)&&r) = r THEN RSIDEOPEN : ELSE RSIDEWALL
2470   :
2480   REMark set locations and sizes for next position ahead
2490   REMark allowing for the 3D perspective
2500   xxx = xx : rx = rxx : yyy = yy
2510   ht = hht : yinc = yinc / shrink : xinc = xinc / shrink
2520 END DEFine CELL
2530 :
2540 DEFine PROCedure LSIDEOPEN
2550   REMark left hand side is open
2560   INK #3,sideopen%
2570   FILL #3,1
2580   LINE #3,xxx,yy TO xx,yy TO xx,yy+hht TO xxx,yy+hht TO xxx,yy
2590   FILL #3,0
2600   INK #3,7
2610 END DEFine LSIDEOPEN
2620 :
2630 DEFine PROCedure LSIDEWALL
2640   REMark left hand side is closed (WALL)
2650   INK #3,sidewall%
2660   FILL #3,1
2670   LINE #3,xxx,yyy TO xx,yy TO xx,yy+hht TO xxx,yyy+ht TO xxx,yyy
2680   FILL #3,0
2690   INK #3,7
2700 END DEFine LSIDEWALL
2710 :
2720 DEFine PROCedure RSIDEOPEN
2730   REMark right hand side is open
2740   INK #3,sideopen%
2750   FILL #3,1
2760   LINE #3,rx,yy TO rxx,yy TO rxx,yy+hht TO rx,yy+hht TO rx,yy
2770   FILL #3,0
2780   INK #3,7
2790 END DEFine RSIDEOPEN
2800 :
2810 DEFine PROCedure RSIDEWALL
2820   REMark right hand side is closed (WALL)
2830   INK #3,sidewall%
2840   FILL #3,1
2850   LINE #3,rx,yyy TO rxx,yy TO rxx,yy+hht TO rx,yyy+ht TO rx,yyy
2860   FILL #3,0
2870   INK #3,7
2880 END DEFine RSIDEWALL
2890 :
2900 DEFine PROCedure OPENEXIT
2910   INK #3,exitcol% : REMark exit ahead
2920   REMark if we are heading west, we must be able to see entrance
2930   REMark which is BLOCKED OFF (we can't exit that way)
2940   REMark entrance is shown as FILLED, exit UNFILLED
2950   IF directn = 3 THEN FILL #3,1
2960   LINE #3,xxx,yyy TO rx,yyy TO rx,yyy+ht TO xxx,yyy+ht TO xxx,yyy
2970   IF directn = 3 THEN FILL #3,0
2980   INK #3,7
2990 END DEFine OPENEXIT
3000 :
3010 DEFine PROCedure WALLEXIT
3020   INK #3,wall% : REMark wall ahead
3030   FILL #3,1
3040   LINE #3,xxx,yyy TO rx,yyy TO rx,yyy+ht TO xxx,yyy+ht TO xxx,yyy
3050   FILL #3,0
3060   INK #3,7
3070 END DEFine WALLEXIT
3080 :
3090 DEFine PROCedure MAP_MAZE
3100   REMark this routine draws the opening 2D plan view
3110   CLS #3
3120   FOR dn = 1 TO down + 1 : BLOCK #3,14*across + 2,1,14,11*dn,7
3130   FOR ac = 1 TO across+1 : BLOCK #3,2,11*down + 1,ac*14,11,7
3140   FOR dn = 1 TO down
3150     FOR ac = 1 TO across
3160       IF (maze(dn,ac)&&2) = 2 THEN BLOCK #3,2,10,14*(ac+1),11*dn+1,0
3170       IF (maze(dn,ac)&&4) = 4 THEN BLOCK #3,12,1,14*ac+2,11*(dn+1),0
3180     END FOR ac
3190   END FOR dn
3200   BLOCK #3,2,10,14,11*iny+1,0
3210   BLOCK #3,2,10,14*(across+1),11*outy+1,0
3220   INK #3,5 : CURSOR #3,2,11*iny+1 : PRINT #3,CHR$(189)
3230   CURSOR #3,14*(across+1)+2,11*outy+1 : PRINT #3,CHR$(189)
3240 END DEFine MAP_MAZE
3250 :
3260 DEFine PROCedure MAKE_A_MAZE
3270   REMark this routine creates a maze, mapped in the array maze()
3280   REMark only one guaranteed way through.Co-ordinates start from 1,1
3290   REMark entrance on west, at iny (down), inx (across, always 1)
3300   REMark exit on east of maze, at outy (down), outx (across)
3310   REMark bit 0 = exit to north of this location
3320   REMark bit 1 = exit to east of tis location
3330   REMark bit 2 = exit to south of this location
3340   REMark bit 3 = exit to west of this location
3350   REMark bit 4 = we have already visited this square and can return
3360   REMark bit 5 = leads to dead end, don't return here
3370   DIM maze(down + 1, across + 1)
3380   :
3390   inx = 1 : iny = RND(1 TO down) : REMark set entrance
3400   x = inx : y = iny : REMark start mapping from entrance
3410   REMark flag the entrance as a dead end, so program will not
3420   REMark attempt to exit via the entrance! (set bit 5 of entry)
3430   maze(y,x) = maze(y,x) || 32
3440   :
3450   outy = RND(1 TO down) : outx=across : REMark map exit
3460   :
3470   REMark set edges as 'dead ends' to prevent exit
3480   FOR ac = 1 TO across : maze(0,ac) = 32 : maze(down+1,ac) = 32
3490   FOR dn = 1 TO down : maze(dn,0) = 32 : maze(dn,across+1) = 32
3500   maze(iny,inx) = maze(iny,inx) || 8 : REMark there is entry west
3510   maze(outy,outx) = maze(outy,outx) || 2 : REMark and exit east
3520   :
3530   REPeat outer
3540     IF (maze(y,x+1)&&48)<>0 AND (maze(y,x-1)&&48)<>0 AND (maze(y+1,x)&&48)<>0 AND (maze(y-1,x)&&48)<>0 THEN
3550       REMark we have come to a dead end, so back off along the
3560       REMark 'visited' trail indicated by bit 4 and exit bits
3570       maze(y,x)=(maze(y,x)&&239)||32 : REMark dead end
3580       IF (maze(y-1,x) && 20) = 20 THEN y = y - 1 : NEXT outer
3590       IF (maze(y,x+1) && 24) = 24 THEN x = x + 1 : NEXT outer
3600       IF (maze(y+1,x) && 17) = 17 THEN y = y + 1 : NEXT outer
3610       IF (maze(y,x-1) && 18) = 18 THEN x = x - 1 : NEXT outer
3620       EXIT outer : REMark no backtrack possible, maze complete
3630     END IF
3640     :
3650     REPeat inner
3660       REMark try a random move to generate a new branch off route
3670       rand_no = RND(0 TO 9)
3680       REMark slight bias towards vertical movement to ensure
3690       REMark indirect routes toward exit on the east
3700       newx = x + (rand_no = 0 OR rand_no = 1)-(rand_no = 5 OR rand_no = 6)
3710       newy = y + (rand_no = 2 OR rand_no = 3 OR rand_no = 4)-(rand_no = 7 OR rand_no = 8 OR rand_no = 9)
3720       REMark must be unvisited and not leading to dead end
3730       REMark bits 4-5 must be reset
3740       IF (maze(newy,newx)&&48) = 0 THEN EXIT inner
3750     END REPeat inner
3760     :
3770     REMark flag new position as visited, but we can return to it
3780     REMark this route leads to a dead end - follow the trail of
3790     REMark set bit 4s to retrace our steps
3800     maze(newy,newx) = maze(newy,newx) || 16
3810     :
3820     REMark we know where to move from and to, so break down "wall"
3830     SELect ON rand_no
3840       =7,8,9 : maze(y,x) = maze(y,x) || 1 : maze(newy,newx) = maze(newy,newx) || 4 : REMark exit north from previous to south of new (up)
3850       =0,1 : maze(y,x) = maze(y,x) || 2 : maze(newy,newx) = maze(newy,newx) || 8 : REMark east of old to west of new (right)
3860       =2,3,4 : maze(y,x) = maze(y,x) || 4 : maze(newy,newx) = maze(newy,newx) || 1 : REMark south of old to north of new (down)
3870       =5,6 : maze(y,x) = maze(y,x) || 8 : maze(newy,newx) = maze(newy,newx) || 2 : REMark west of old to east of new (left)
3880     END SELect
3890     :
3900     x = newx : y = newy : REMark we are now at a new y,x co-ord
3910     :
3920   END REPeat outer
3930   :
3940   REMark &&239 masks out the 'visited' bit 4 which may be set
3950   REMark || 32 flags it as a 'dead end' or 'dont return this way'
3960   maze(outy,outx) = (maze(outy,outx) && 239) || 32
3970   :
3980 END DEFine MAKE_A_MAZE
3990 :
4000 DEFine PROCedure TEST
4010   REMark used for testing display LINE extents on various display
4020   REMark resolutions, routine not used bymain program, delete
4030   REMark given scale 100, 512x256,  x is 0-149   y is 0-99
4040   REMark given scale 100, 512x384,  x is 0-99    y is 0-99
4050   REMark given scale 100, 640x320,  x is 0-149   y is 0-99
4060   REMark given scale 100, 640x480,  x is 0-99    y is 0-99
4070   WINDOW 640,320,0,0 : SCALE 100,0,0 : CLS
4080   FOR a = 0 TO 500
4090     AT 0,0 : PRINT a
4100     LINE 0,0 TO 0,a;0,0 TO a,0
4110     IF INKEY$(-1) = CHR$(27) THEN EXIT a
4120   END FOR a
4130 END DEFine TEST
4140 :
4150 DEFine FuNction MOVE_IS_OK% (which_direction)
4160   LOCal wh_di,move_ok%
4170   :
4180   REMark copy last parameter to local variable to prevent Select
4190   REMark On Last Parameter bug in some ROM versions
4200   wh_di = which_direction
4210   :
4220   REMark if heading in the same direction, actually move (stp%=1)
4230   REMark otherwise turn only (stp%=0)
4240   stp% = (wh_di = directn)
4250   :
4260   ok% = 0 : REMark assume not OK to move in this direction
4270   SELect ON wh_di
4280     =0 : REMark northward
4290          IF y > 1 AND (maze(y,x)&&1)=1 THEN y = y - stp% : ok% = 1
4300     =1 : REMark eastward
4310          IF x < across AND (maze(y,x)&&2)=2 THEN x = x+stp%: ok% = 1
4320     =2 : REMark southward
4330          IF y < down AND (maze(y,x)&&4)=4 THEN y = y+stp% : ok% = 1
4340     =3 : REMark westward
4350          IF x > 1 AND (maze(y,x)&&8) = 8 THEN x = x - stp% : ok% = 1
4360   END SELect
4370   IF ok% = 1 : directn = wh_di : REMark the new direction
4380   RETurn ok%
4390 END DEFine MOVE_IS_OK%
4400 :
4410 REMark next line prevents QLiberation of Sa procedure
4420 REMark $$off
4430 DEFine PROCedure Sa
4440   QSAVE flp1_MAZE_SAVER : SAVE flp1_MAZE_SAVER_bas
4450   QSAVE win1_mazes_MAZE_SAVER : SAVE win1_mazes_MAZE_SAVER_bas
4460 END DEFine Sa
4470 REMark $$on
